/***************************************************************************/
/***                                                                     ***/
/***                rcc8.h                                               ***/
/***                                                                     ***/
/***       Ronny Fehling, Bernhard Nebel, Jochen Renz  - March 1998      ***/
/***                                                                     ***/
/***         fehling, nebel, renz@informatik.uni-freiburg.de             ***/
/***                                                                     ***/
/***          http://www.informatik.uni-freiburg.de/~sppraum             ***/
/***                                                                     ***/
/***                      Institut fuer Informatik                       ***/
/***                     Albert-Ludwigs-Universitaet                     ***/
/***                           Am Flughafen 17                           ***/
/***                       79110 Freiburg, Germany                       ***/
/***                                                                     ***/
/***************************************************************************/


#define MAXCSP 10000            /* # of Nodes, a CSP can have maximal */
#define MAXTRIAL 200000
#define MAXWT 22
#define MAXHEADER 200           /* # of Nodes used in the experiments */
#define NV_UPPER_LIMIT 20000000 /* If more than this # of nodes visited, fail*/
#define RELTYPE short int 
#define RELTYPESIZE sizeof(RELTYPE)

/* If this is set, dynamic memory allocation is used */
#define DYNAMIC  

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/resource.h>
#include <limits.h>
#define DEFAULTVAL 100000000

/* Coding of the RCC8 relations */
/* coded as binary, assuming int 8bit or more */
#define DC 		1
#define EC 		2
#define PO		4
#define TPP		8
#define NTPP		16
#define	TPPI		32
#define NTPPI		64
#define	EQ		128
#define	DALL		255

/* Number of possible disjunctions (including 0 for empty Relation) */
#define MAXSET		256

/* Number of basic relations */
#define	MAXREL		8


struct entry {
  short int row, col;
};

typedef struct header {
  char name[100];
  struct header *next;
} hdr, *hp;




/* Declaration of functions depending of dynamic or static structure */
#if defined(DYNAMIC)
  extern int path_cons1(RELTYPE **csp, int maxnodeid, int node1, int node2);
  extern int path_cons_wq (RELTYPE **csp, int maxnodeid, int node1, int node2);
  extern int path_cons_vb (RELTYPE **csp, int maxnodeid, int node1, int node2);
  extern int global_cons(RELTYPE **csp, int maxnodeid, int node1, int node2);
#else
  extern int path_cons1(RELTYPE csp[MAXCSP][MAXCSP], int maxnodeid, int node1, int node2);
  extern int path_cons_wq (RELTYPE csp[MAXCSP][MAXCSP], int maxnodeid, int node1, int node2);
  extern int path_cons_vb (RELTYPE csp[MAXCSP][MAXCSP], int maxnodeid, int node1, int node2);
  extern int global_cons(RELTYPE csp[MAXCSP][MAXCSP], int maxnodeid, int node1, int node2);
#endif

